﻿using System;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.executeButton.Click += executeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 실행 버튼 클릭시 처리하기 - executeButton_Click(sender, e)

        /// <summary>
        /// 실행 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void executeButton_Click(object sender, EventArgs e)
        {
            this.executeButton.Enabled = false;

            await Task.Factory.StartNew(() => Execute());

            this.executeButton.Enabled = true;

            this.messageLabel.Text = string.Empty;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 실행하기 - Execute()

        /// <summary>
        /// 실행하기
        /// </summary>
        private void Execute()
        {
            for(int i = 0; i < 100; i++)            
            {
                Invoke(new MethodInvoker(() => { this.messageLabel.Text = i.ToString(); }));

                Thread.Sleep(10);
            }
        }

        #endregion
    }
}